//		Copyright © 1998	Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Utility functions for setting up and executing CAM requests.

#ifndef ST_CAMUTILS_H
#define ST_CAMUTILS_H

#include <CAM.h>

#include "SCSIData.h"

// Initialize/uninitialize the BeOS CAM interface.
status_t camInit(void);
status_t camExit(void);

// Allocate and initialize a CCB structure.
CCB_HEADER *getCCB(uint8 functionCode, uint8 pathID, uint8 targetID, uint8 lun,
						 uint32 flags = 0);

// Release a CCB structure.
void freeCCB(CCB_HEADER *pCCB);

// Perform an XPT action using the given CCB.
long xptAction(CCB_HEADER *pCCB);

// Inquire the highest assigned path ID.
uint8 getHighestPathID(void);

// Inquire device type information.
status_t getDeviceType(uint8 pathID, uint8 targetID, uint8 lun,
							  uint8 &deviceType,
							  SCSIInquiryData *const pInquiryData = 0);

#endif // ST_CAMUTILSH
